package com.engine.salary.mapper.hrm;

import com.engine.salary.entity.hrm.po.HrmSnapshotPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.Date;
import java.util.List;

public interface HrmSnapshotMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<HrmSnapshotPO> listAll();

    List<HrmSnapshotPO> snapshot(@Param("employeeId")Long employeeId, @Param("snapshotTime")Date snapshotTime);

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<HrmSnapshotPO> listSome(HrmSnapshotPO hrmSnapshot);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    HrmSnapshotPO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param hrmSnapshot 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(HrmSnapshotPO hrmSnapshot);


    /**
     * 修改，修改所有字段
     *
     * @param hrmSnapshot 修改的记录
     * @return 返回影响行数
     */
    int update(HrmSnapshotPO hrmSnapshot);

    /**
     * 修改，忽略null字段
     *
     * @param hrmSnapshot 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(HrmSnapshotPO hrmSnapshot);

    /**
     * 删除记录
     *
     * @param hrmSnapshot 待删除的记录
     * @return 返回影响行数
     */
    int delete(HrmSnapshotPO hrmSnapshot);

    /**
     * 批量删除记录
     *
     * @param ids 主键id集合
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);

    void deleteBySnapshotTime(Date snapshotTime);

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<HrmSnapshotPO> currentEmpData();


}